#!/usr/bin/python

# $Id: hello.py,v 1.42 2004/06/03 06:28:53 brinkman Exp $
# (c) 2004, Peter Brinkmann (brinkman@math.uiuc.edu)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation (http://www.gnu.org/copyleft/gpl.html).


import sys
from PySZG import *
from math import *
from random import *

fw=arDistSceneGraphFramework()
if not fw.init(sys.argv):
	raise 'Unable to initialize framework.'
ifo=arInterfaceObject()
ifo.setInputDevice(fw.getInputDevice())

# configure stereo view
fw.setEyeSpacing(6.0/(2.54*12.0))
fw.setClipPlanes(0.3,1000.0)
fw.setUnitConversion(1.0)

tm=ar_translationMatrix(3,-3,0)
m=ar_rotationMatrix('y',pi)*ar_scaleMatrix(0.6)

wID=dgTransform('world',fw.getNavNodeName(),arMatrix4())
dgLight('light0',fw.getNavNodeName(),0,arVector4(0,0,1,0),arVector3(1,1,1))
dgLight('light1',fw.getNavNodeName(),1,arVector4(0,0,-1,0),arVector3(1,1,1))
dgLight('light2',fw.getNavNodeName(),2,arVector4(0,-1,0,0),arVector3(1,1,1))
dgLight('light3',fw.getNavNodeName(),3,arVector4(0,1,0,0),arVector3(1,1,1))

mID=dgTransform('billboard transform','world',m)
dgBillboard('billboard','billboard transform',1,'hello world')

tmID=dgTransform('local1','world',tm)
dgTexture('texture1', 'local1', 'WallTexture1.ppm')
dgMaterial('material1', 'texture1',arVector3(1,0.6,0.6))
mesh=arPyramidMesh()
mesh.attachMesh('mesh1','material1')

nl=8
lp=[]
for i in range(nl):
	lp.extend([-3+cos(pi*i/nl),3+sin(pi*i/nl),0,
			-3+cos(pi+pi*i/nl),3+sin(pi+pi*i/nl),0])
co=[]
for i in range(2*nl):
	co.extend([random(),random(),random(),1])
lpID=dgPoints('line points','world',2*nl,lp);
cID=dgColor4('line colors','line points',2*nl,co);
dgDrawable('lines','line colors',DG_LINES,nl)

if not fw.start():
	raise 'Unable to start framework.'
if not ifo.start():
	raise 'Unable to start interface.'

if __name__=='__main__':
	import time
	print 'Use dkill or press Ctrl-C to quit.'
	rzm=ar_rotationMatrix('z',0.5/180.0*pi)
	rxm=ar_rotationMatrix('x',1.0/180.0*pi)
	ifo.setNavMatrix(ar_translationMatrix(0,5,-5))
	while 1:
		ar_setNavMatrix(ifo.getNavMatrix().invert())
		fw.loadNavMatrix()
		dgTransform(wID,ifo.getObjectMatrix())
		fw.setViewer()
		m=m*rzm
		tm=tm*rxm
		dgTransform(mID,m)
		dgTransform(tmID,tm)
		dgColor4(cID,1,[randint(0,2*nl-1)],[random(),random(),random(),1])
		time.sleep(0.01)
